import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class gps_tilt_drawing extends PApplet {

/* allow the user to draw on the axes, then
use a keypress to export an image file of the finished
sketch */

int bg = color(242,218,169);
int ox = 75;
int oy = 100;
int ly = 200;
int lx = 400;
int sep = 100; //separation in y between upper and lower plots
boolean flag = false; //used with savePath
int mode = 0; //used with the button object

Button button; //button object used for file saving

public void setup() {
  size(500,700);
  frame.setTitle("Drag to draw; Press the button to save");
 button = new Button(25,25,30,color(204),color(255),color(0)); 
  PFont font1;
font1 = loadFont("ImprintMT-Shadow-32.vlw");
PFont font2;
font2=loadFont("Rockwell-12.vlw");
PFont font3;
font3=loadFont("ImprintMT-Shadow-12.vlw");
  background(bg);
  stroke(0);
  line(ox,oy,ox,oy+ly); //draw the vertical axis of the top plot
  line(ox,oy+ly,ox+lx,oy+ly); //draw the horizontal axis of the top plot
  line(ox,sep+oy+ly,ox,sep+oy+2*ly); // draw vert axis of lower plot
  line(ox,sep+oy+2*ly,ox+lx,sep+oy+2*ly); //draw horz axis of lower plot
  for (int i = 1; i<600; i+=5){
    point(ox+100,oy+i);
    point(ox+250,oy+i);
  }
  textFont(font1);
  fill(89,91,95);
  text("GPS",ox,oy-10);
  text("tilt",ox,sep+oy+ly-10);
  textFont(font2);
  String lines = "caldera inflation begins";
  textLeading(15);
  fill(0);
  text(lines,ox+110,sep+oy+2*ly+10,60,100);
  String lines2 = "eruption begins";
  text(lines2,ox+260,sep+oy+2*ly+10,60,100);
  textFont(font3);
  fill(89,91,95);
  String lines3 = "A - B distance";
  textAlign(RIGHT);
  text(lines3,ox-75,oy+ly/2,60,100);
  String lines4 = "C direction";
  text(lines4,ox-75,sep+oy+3*ly/2,60,100);
  text("time",ox+lx,sep+oy+2*ly+12);
  text("time",ox+lx,oy+ly+12);
  
}

public void draw() {
  
  strokeWeight(2);
  if (mousePressed == true) {
    stroke(48,107,198);
  line(mouseX,mouseY,pmouseX,pmouseY);
  }
  if ((keyPressed == true) && (key == 'e')) {
   stroke(bg);
   strokeWeight(7);
  line(mouseX,mouseY,pmouseX,pmouseY); 
  }
  manageButtons();
  if (mode == 1) {
    flag = true;
    println("you pressed the save button");
  }
  if (flag) {
    flag = false;
    //fooFunc();
  }
}

public void manageButtons() {
  button.update();
  button.display();
}

public void mousePressed() {
  if (button.press() == true) {
    mode = 1;
  }
}

public void mouseReleased() {
  button.release();
}

class Button  {
  int x, y;      // the x and y coordinates
  int size;      // dimension in width and height
  int baseGray;  //default gray value
  int overGray;  //value when mouse is over the button
  int pressGray; //value when the mouse is over and pressed
  boolean over = false;  //true when the mouse is over
  boolean pressed = false;  //true when the mouse is over and pressed
  
  Button(int xp, int yp, int s, int b, int o, int p){
    x = xp;
    y = yp;
    size = s;
    baseGray = b;
    overGray = o;
    pressGray = p;
  }
  
  public void update() {      //updates the over field every frame
  if ((mouseX >= x-size/2) && (mouseX<= x+size/2) && (mouseY >=y-size/2) && (mouseY<= y+size/2)) {
    over = true;
  }
  else {
    over = false;
  }
  }
  
  public boolean press() {
    if (over == true) {
      pressed = true;
      return true;
    }
    else {
      return false;
    }
  }
  
  public void release() {
    pressed = false;    //set to false when mouse is released
  }
  
  public void display() {
    if (pressed == true) {
      fill(pressGray);
    }
    else if (over == true) {
      fill(overGray);
    }
    else {
      fill(baseGray);
    }
    stroke(255);
    ellipse(x,y,size,size);
  }
}
/*
void fooFunc() {
  String savePath = selectOutput(".jpg, .gif, .png supported; default is tiff");
  if (savePath == null) {
    println("No output file was selected. bummer!");
  }
    else {
      println(savePath);
      save(savePath);
    }
  mode = 0;
}*/


  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "gps_tilt_drawing" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
